10 KEY OFF: COLOR 1,0: CLS : LOCATE 8, 1
15 COLOR 6
20 PRINT "              ͻ"
30 PRINT "               Ŀ "
40 PRINT "                                                            "
50 PRINT "                                                            "
55 PRINT "                                                            "
60 PRINT "                                                            "
65 PRINT "                                                            "
70 PRINT "                "
80 PRINT "              ͼ"
90 PRINT
91 COLOR 9
92  LOCATE 11, 19: PRINT "---=== FOUCAULT TEST ANALYSIS ===---"
93  LOCATE 12, 19: PRINT "                (5 ZONES)                 "
94  LOCATE 13, 19: PRINT "       by R.W. Sinnot and R. Dawes        "
96  LOCATE 14, 19: PRINT "                   1.0                    "
98  LOCATE 23, 30: COLOR 13: PRINT "Press ENTER to begin"; : COLOR 9
100 FOR I = 0 TO 30000
102 A$ = INKEY$
104 IF A$ <> "" THEN GOTO 108
106 NEXT I
108 REM   FOUCAULT MIRROR TEST
110 REM   FROM S&T, FEB 90, P 1989
120 Z = 5:            'Number of zones
130 DIM M(Z, 11), DELTA(5, 11), SUM(10), AVG(10)
132 DIM A(10), B(10), C(10), D(10), E(10), F(10)
135 DIM V(10), X(10), Y(10), Z(10)
140 COLOR 11, 1: CLS
150 PRINT "AVAILABLE FILES ARE:": PRINT
160 FILES "*.DTA": PRINT : PRINT
170 LOCATE 15, 1: PRINT "SELECT A DATA FILE (without .DTA extension) "
175 LOCATE 16:   PRINT "OR PRESS ENTER TO QUIT "; : INPUT DB$
180 IF DB$ = "" THEN END
190 DB$ = DB$ + ".DTA"
200 OPEN DB$ FOR INPUT AS #1
210 INPUT #1, REMARK$
220 CLS 0: LOCATE 2, 20
230 PRINT DB$: PRINT
240 PRINT REMARK$: PRINT
250 INPUT #1, FL, DIAM, NZ%, M%, FK
260 PRINT "FOCAL LENGTH - "; FL; "INCHES     CLEAR APERTURE "; DIAM; " INCHES"
270 PRINT : LOCATE , 15: PRINT NZ%; " ZONES", M%; " READINGS      ADJUSTMENT: "; FK: PRINT
272 REM 5-ZONE
276     Z(1) = .316: Z(2) = .548: Z(3) = .707: Z(4) = .837: Z(5) = .945
280     GOTO 300
282 REM 7-ZONE (Not implemented)
284     ' 7-ZONES ARE .267, .463, .598, .707, .802, .886, .964
286     ' ZONES 2,4,6,7
288     'V(1) = AVG(2): V(2) = AVG(4): V(3) = AVG(6): V(4) = AVG(7)
290     'Z(1) = .463: Z(2) = .707: Z(3) = .886: Z(4) = .964
292 REM ZONES 1,3,5,7
294     'V(1) = AVG(1): V(2) = AVG(3): V(3) = AVG(5): V(4) = AVG(7)
296     'Z(1) = .267: Z(2) = .598: Z 3) = .802: Z(4) = .964
300 REM
302 PRINT "Effective zone radius  ";
304 FOR I = 1 TO Z: PRINT USING "+#.###   "; Z(I); : NEXT I: PRINT : PRINT
308 FOR I% = 1 TO NZ%: SUM(I%) = 0: AVG(I%) = 0: V(I%) = 0: NEXT I%
310 FOR J% = 1 TO M%: PRINT "           Test #"; J%; "   ";
312   FOR I% = 1 TO NZ%
314     INPUT #1, DELTA(J%, I%)
320     SUM(I%) = SUM(I%) + DELTA(J%, I%)
330     PRINT USING "+#.###   "; DELTA(J%, I%);
340   NEXT I%
350 PRINT
360 NEXT J%
370 PRINT : PRINT "Average test readings  ";
380 FOR I% = 1 TO NZ%:
390   AVG(I%) = SUM(I%) / M%:
400   PRINT USING "+#.###   "; AVG(I%);
410 NEXT I%: PRINT
420 CLOSE #1
500  FOR I = 1 TO 5: V(I) = AVG(I) * 2: NEXT I
600  PRINT : PRINT "              Doubled  ";
640  FOR I = 1 TO Z:  PRINT USING "+#.###   "; V(I); : NEXT I: PRINT
650  R1 = FL
660  W = DIAM
670  LOCATE 23, 1: INPUT "PRESS RETURN WHEN READY "; A$
680  CLS
740 RR = R1 * 2
750 R = W / 2
760 FOR I = 1 TO Z:  X(I) = Z(I) * R:  NEXT I
770 L = .000022:  REM  Wavelength in inches
780 FOR I = 1 TO Z
790    F(I) = (X(I) / (2 * RR * RR * L)) * (X(I) * X(I) / RR - V(I))
800    A(I) = X(I) ^ 9: B(I) = X(I) ^ 7: C(I) = X(I) ^ 5: D(I) = X(I) ^ 3: E(I) = X(I)
810    M(I, 1) = A(I): M(I, 2) = B(I): M(I, 3) = C(I): M(I, 4) = D(I): M(I, 5) = E(I)
820 NEXT I
830 FOR I = 1 TO Z
840    M(I, Z + 1) = F(I)
850 NEXT I
860 N = Z: GOSUB 1120: HI = -999: LO = 999
870 A = M(1, 6): B = M(2, 6): C = M(3, 6): D = M(4, 6): E = M(5, 6)
880 D1 = -A * R ^ 8 / 5 - B * R ^ 6 / 4 - C * R ^ 4 / 3 - D * R ^ 2 / 2
890 GOSUB 1230: LINE (H0, YC)-(H0 + 1, YC), 13
900 FOR I = 0 TO 1.001 STEP .005
910    X = I * R: Y = A * X ^ 10 / 10 + B * X ^ 8 / 8 + C * X ^ 6 / 6 + D * X ^ 4 / 4 + D1 * X ^ 2 / 2
920    LINE -(H0 + I * W1, YC - Y * W1), 13
930    'LOCATE 16, 28: COLOR 4, 0: PRINT "zone "; : PRINT USING " #.##"; I;
935    'PRINT "   surface error "; : PRINT USING "#.####"; Y;
940    IF Y > HI THEN HI = Y
950    IF Y < LO THEN LO = Y
960 NEXT I
962 FOR I = 1 TO Z:
964    X = Z(I) * R: Y(I) = A * X ^ 10 / 10 + B * X ^ 8 / 8 + C * X ^ 6 / 6 + D * X ^ 4 / 4 + D1 * X ^ 2 / 2
966    CIRCLE (H0 + Z(I) * W1, YC - Y(I) * W1), 1, 15
968 NEXT I
970 PRINT : COLOR 3: LOCATE 20
980 PRINT "Coefficient D1: "; : COLOR 12: PRINT USING "###.####"; D1: COLOR 3
990 PRINT "Surface error:  "; : COLOR 12: PRINT USING "###.###"; HI - LO: COLOR 3
1000 PRINT "Wavefront error:"; : COLOR 12: PRINT USING "###.###"; 2 * (HI - LO);
1010 LOCATE 20, 36: COLOR 6:  PRINT "Want to try a different D1 (y or n)          ";
1020 LOCATE 20, 72: INPUT ""; Q$
1024 REM The following 3 lines attempt to find the optimum D1--doesn't work
1025 'IF q$ <> "A" THEN 1030
1026 'D2 = -(8 / 5) * A * R ^ 7 - (6 / 4) * B * R ^ 5 - (4 / 3) * C * R ^ 3 - DR
1027 'LOCATE 22, 36: PRINT "OPT D1 IS "; : PRINT USING "+#.#### "; D2: GOTO 1050
1030 IF Q$ <> "y" AND Q$ <> "Y" THEN GOTO 140
1040 LOCATE 21, 36: PRINT SPACE$(40)
1050 LOCATE 21, 36: INPUT "New value for D1     "; D1
1055 LOCATE 21, 36: PRINT SPACE$(40)
1060 HI = -999: LO = 999: GOTO 890
1080 END
1090 REM
1100 REM  Solve 4 linear equations for 4 unknonws
1110 REM      (BYTE, August, 1983, page 396)
1120 DE = 1
1130 Y = N + 1: FOR X = 1 TO N: Y = Y + 1: M(X, Y) = 1: NEXT X
1140 FOR G = 1 TO N
1150    J = 2 * N + 1: DV = M(G, G): DE = DE * DV
1160    FOR H = 1 TO J: M(G, H) = M(G, H) / DV: NEXT H
1170    FOR S = 1 TO N
1180       Q = M(S, G): IF S = G THEN GOTO 1200
1190       FOR T = 1 TO J: M(S, T) = M(S, T) - M(G, T) * Q: NEXT T
1200    NEXT S: NEXT G
1210 RETURN
1220 REM
1230 REM      PREPARE CHART
1240 SCREEN 9: COLOR 1, 0: CLS
1250 Y1 = 107: Y2 = 113: YC = 110
1260 W1 = 480: H0 = 100: H1 = 105: H3 = H0 + W1
1270 P1 = H0 + W1 * Z(1): P2 = H0 + W1 * Z(2)
1275 P3 = H0 + W1 * Z(3): P4 = H0 + W1 * Z(4)
1276 P5 = H0 + W1 * Z(5)
1280 FOR I = 0 TO 200 STEP 10
1290    LINE (H0, 10 + I)-(H3, 10 + I), 8, , &HC000
1300 NEXT I
1310 LINE (H0, 10)-(H0, 210), 2: LINE (H0, YC)-(H3, YC), 2
1320 LINE (H0, 10)-(H1, 10), 2: LINE (H0, 60)-(H1, 60), 2
1330 LINE (H0, 160)-(H1, 160), 2: LINE (H0, 210)-(H1, 210), 2
1340 LINE (P1, Y1)-(P1, Y2), 2: LINE (P2, Y1)-(P2, Y2), 2
1350 LINE (P3, Y1)-(P3, Y2), 2: LINE (P4, Y1)-(P4, Y2), 2
1360 LINE (P5, Y1)-(P5, Y2), 2: LINE (H3, Y1)-(H3, Y2), 2
1370 COLOR 3, 0
1380 LOCATE 1, 1: PRINT "+0.2 wave"
1390 LOCATE 5, 1: PRINT "+0.1 wave"
1400 LOCATE 8, 1: PRINT "  0  wave"
1410 LOCATE 12, 1: PRINT "-0.1 wave"
1420 LOCATE 15, 1: PRINT "-0.2 wave"
1430 LOCATE 17, 11: PRINT "Center"
1440 LOCATE 17, 72: PRINT "Edge"
1450 LOCATE 1, 10 + INT(67 - LEN(REMARK$)) / 2: COLOR 9: PRINT REMARK$: COLOR 3
1460 RETURN
1470 REM  SINNOT'S ORIGINAL DATA
1480 'DATA .3,.6,.8,.95
1490 'DATA  58.3, 13.1
1500 'DATA .349, .480,.569,.654
1510 'DATA .1745, .240, .2845, .327
